#!/usr/bin/env python
import sys


#Az alabbi demo program a Python alprogramok tipikus vonasait
#mutatja be.


#Fuggveny definialasa (ketelemu tuple-t ad vissza)
def multiply(number):
    return (2*number, 3*number)

#Hatokor, lathatosag (a fuggveny torzse uj blokkot definial)
x = 1
def outer():
  x = 2
  def inner():
    print x         # 2-t fog kiirni, a belso valtozo van ervenyben
    print locals()  #kiirja a lokalis namespace-t
    print globals() #kiirja a globalis namespace-t, ebben x = 1!
  inner()


#Kizarolag referencia szerinti parameteratadas van.
#Ha a parameter immutable objektum, akkor a fuggveny nem tudja megvaltoztatni
#az ereket, ha mutable, akkor a formalis parameter erteke tetszolegesen
#valtoztathato.
x = 1
def inc(i): #Az aktualis parameter, mint referencia lemasolodik a formalis parameterbe.
  #x es i is ugyanarra az objektumra hivatkozik  
  i = i + 1 #mivel ez az objektum immutable, ezert uj objektum jon letre, i erre fog hivatkozni

inc(x)
print x  
#1-et fog kiirni, mivel:
#Az aktualis parameter, mint referencia lemasolodik a formalis parameterbe.
#Ekkor x es i is ugyanarra az objektumra hivatkozik
#Mivel az int immutable tipus, valtoztataskor uj objektum job letre, 
#es i mar erre fog hivatkozni.


l = []
def add(lista, elem):
    lista.append(elem)

add(l, 100)
#Mivel a lista mutable tipus, ezert a fuggveny altal veghezvitt modositas 
#latszani fog a fuggvenytorzs vegrehajtasa utan is.


#Default erteke lehet a parametereknek (a kotelezok utan adjuk meg ezeket)
def printfile(string, file=sys.stdout):
    if file == sys.stdout:
        print string
    else:
        f = open(file, 'w')
        f.write("%s\n" % string)
        f.close()

#Megfeleltetes lehetseges pozicio es nev szerint is:
printfile("Hello World!")
printfile("Hello World!", "/tmp/hello.out")
printfile(string="Hello World", file="/tmp/hello.out")



#Valtozo argumentumszamu fuggveny:
def printstrings(separator='\n', *args):
    stringlist = []
    for str in args:
        stringlist.append(str)
    print separator.join(stringlist)

#Kulcsszavas argumentumok a ket csillagos dictionary-be kerulnek:
def func(arg1, *args, **keywordargs):
    for elem in args:
        print elem
    for key, value in keywordargs:
        print "%s: %s" % (key, value)


#Alprogram-tulterheles nincs a Python-ban
def power(x):
    x^2

def power(x, y): #A masodik definicio felulirja az elsot
    x^y

#power(2) fuggvenyhivas HIBA-t dobna, mivel a power fuggveny-nek ket parametere van.
